function [h]=getHypervolume(values,isMinFirst,isMinSecond)
% Calculates hypervolume for the given population of two-dimensional values
% values: two-dimensional array with solutions
% isMinFirst: set to 1 when the first measure should be minimized, otherwise to 0
% isMinFirst: set to 1 when the second measure should be minimized, otherwise to 0
% Reference point dimensions should be binary (0/1), so the metric values must be normalized!
%
% Created on 08.06.2011 by Igor Vatolkin

front = nonDominated(values,isMinFirst,isMinSecond);
h = 0;
for i=1:length(front(:,1));
    if(isMinFirst && isMinSecond)
        if(i<length(front(:,1)))
            % (x_next-x)*(1-y)
            h = h + (front(i+1,1)-front(i,1))*(1-front(i,2));
        else
            % (1-x)(1-y)
            h = h + (1-front(i,1))*(1-front(i,2));
        end;
    elseif(isMinFirst == 0 && isMinSecond == 0)
        if(i<length(front(:,1)))
            % (x-x_next)*y
            h = h + ( front(i,1)*(front(i,2)-front(i+1,2)) );
        else
            % xy
            h = h + ( front(i,1)*front(i,2) );
        end;
    elseif(isMinFirst == 0 && isMinSecond == 1)
        if(i<length(front(:,1)))
            % x*(y_next-y)
            h = h + ( front(i,1)*(front(i+1,2)-front(i,2)) );
        else
            % x*(1-y)
            h = h + ( front(i,1)*(1-front(i,2)) );
        end;
    else 
        if(i<length(front(:,1)))
            % (x_next-x)*y
            h = h + ( (front(i+1,1)-front(i,1))*front(i,2) );
        else
            % (1-x)*y
            h = h + ( (1-front(i,1))*front(i,2) );
        end;

    end;
end;
